//ppiFM.h
#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>

#include "ppi.h"

typedef unsigned char	UINT8;
typedef unsigned short	UINT16;


#define LINELEN 16 
#define NUMLINES 128//128
#define BUFFERSIZE	(LINELEN * NUMLINES)
#define	DIM2D	2
#define DIM1D	1
#define	MAXROWS	LINELEN //256 // 1400 //2800
#define	MAXCOLS	NUMLINES // 256 // 3400 //3400
#define	MAXIMAGESZ	(MAXROWS * MAXCOLS * sizeof(UINT16) )
#define IQSIZE	(LINELEN * NUMLINES * sizeof(UINT16) )
#define	FILL_ONLY	1
// on STAMP board some bits are shared with network controller
// all bits can't be transfered without changing CPLD
#define PPIVBITS	0x07FF


typedef struct cfgTableStruct
{
	unsigned int cmd, arg;
} CfgTable;

UINT16 *realloc_image();
int fill_verifyBuffer( UINT16 *buf, UINT16 bufX, UINT16 bufY, char pattern, UINT16 value, UINT8 fill );
void fillBuffer( UINT16 *buf, UINT16 bufX, UINT16 bufY, char pattern, UINT16 value );
void showBuffer8( UINT8 *buf, UINT16 bufX, UINT16 bufY, UINT8 mask );
void showBuffer( UINT16 *buf, UINT16 bufX, UINT16 bufY, UINT16 mask );
int config_device( int devFD, CfgTable	*table );
int beMaster(int ppiFD, UINT16 bufX, UINT16 bufY, int dims);
int beSlave(int ppiFD, UINT16 *IQ, UINT16 bufX, UINT16 bufY, int dims);
void processIQ( UINT16 *buf, UINT16 *IQ, UINT16 bufX, UINT16 bufY, UINT16 mask);
void showUsage(char *pgmname);
void closePPI(int ppiFD);
UINT16 *getImage( int ppiFD, UINT16 imgSize );
//void getImage( int ppiFD, UINT16 *iq, UINT16 imgSize );
void *soundproc(void *arg);
