//ppiFM_main.c

/*********************************************
This program is for testing continuous NBFM in BF537
Written By: Jang H. Oh janghoh@vt.edu, S.M. Hasan, hasan@vt.edu
*********************************************/
#include <pthread.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <errno.h>
//#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include <limits.h>
#include <signal.h>
#include <math.h>

/****************************************************************************
  Sound Include files and define
*****************************************************************************/
#include <getopt.h>
#include <linux/soundcard.h>

#define	DACDEVICE	"/dev/dsp"
//#define	MAXFREQ		50000
//#define	BUFSIZE		(2*MAXFREQ)
//short	buf[BUFSIZE];
//#define	PI	((float) 3.141592654)
/*****************************************************************************/

#include "ppi.h"
#include "sigproc.h"
#include <signal.h>

UINT16 *IQ;
int ppiFD, cinx_w = 0, cinx_r = 0, cinx_turn_w = 0, cinx_turn_r = 0;
int size, exit_flag;
short *cirbuf, *cirbuf_i, *cirbuf_q;
int i_in[50];
int ofd;
int i,buf_remainder;
//mutex initialization
pthread_mutex_t	mLock=PTHREAD_MUTEX_INITIALIZER;
//extern short *gImage;
extern UINT16 *gImage;
int bufsize = 32768;
FILE *ofp, *ofpi, *ofpq;
double twopi = 6.2831853;
short cos_tab[628], sin_tab[628];
int	cinx_w_turn=0;

int main(int argc,char *argv[])
{
	pthread_t tid;

// Setting up variables and default values
	int	n;//, i, j;
	char	mode;
	int	retval;
	UINT16	bufX = LINELEN;
	UINT16	bufY = NUMLINES;
	int	dims;//, size;
	size = BUFFERSIZE;
	dims = DIM2D;
	char	buf[size];

// Setting up Circular buffers	
	cirbuf_i = (short*)malloc(bufsize*sizeof(short)); //ojh
	if( cirbuf_i==NULL ) {printf("malloc() error:cir_buf\n"); exit(1);}

	cirbuf_q = (short*)malloc(bufsize*sizeof(short));  //ojh
	if( cirbuf_q==NULL ) {printf("malloc() error:cir_buf\n"); exit(1);}

	cirbuf = (short*)malloc(bufsize*sizeof(short));   //ojh
	if( cirbuf==NULL ) {printf("malloc() error:cir_buf\n"); exit(1);}


// Variables initialization
	char ofilename[] = "out.txt";
	char ofilename1[] = "i_in.txt";
	char ofilename2[] = "q_in.txt";
	
	int	c;
	
// Setting up NCO tables	
	for(i=0;i<628;i++) cos_tab[i] = (short)32000*cos(twopi*(float)i/628.);
	for(i=0;i<628;i++) sin_tab[i] = (short)32000*sin(twopi*(float)i/628.);
	
	i=0;
// Soundcard Initialization and Configuration
	printf("SoundCard opening.... \n");

	if ((ofd = open(DACDEVICE, (O_RDWR) , 0666)) < 0) {
		printf("ERROR: failed to open DAC device %s\n", DACDEVICE);
		exit(1);
	}
	else {
		printf("fd(%d) = open(/dev/dsp)\n", ofd );
	}

	printf("SoundCard IOCTL started.... \n");	

	int replayfreq = 22035;
//	int replayfreq = 43915;
//	wavefreq = 10000;
	int smode = 0, ret = 0;
	int endian = AFMT_S16_LE;
//	int channels = 1;

	if (ioctl(ofd, SNDCTL_DSP_SPEED, &replayfreq) < 0) {
		printf("ERROR: ioctl(SNDCTL_DSP_SPEED,%d) failed, "
			"errno=%d\n", replayfreq, errno);
		exit(1);
	}
	else {
		printf("Configured SNDCTL_DSP_SPEED.... \n");
	}


	if (ioctl(ofd, SNDCTL_DSP_STEREO, &smode) < 0) {
		printf("ERROR: ioctl(SNDCTL_DSP_STEREO,%d) failed, "
			"errno=%d\n", smode, errno);
		exit(1);
	}
	else {
		printf("Configured SNDCTL_DSP_STEREO.... \n");
	}


	if (ioctl(ofd, SNDCTL_DSP_SAMPLESIZE, &endian) < 0) {
		printf("ERROR: ioctl(SNDCTL_DSP_SAMPLESIZE,0x%x) failed, "
			"errno=%d\n", endian, errno);
		exit(1);
	}
	else {
		printf("Configured SNDCTL_DSP_SAMPLESIZE.... \n");
	}

// PPI Initialization 
	if (argc < 2){
		showUsage(argv[0]);
		return(1);
	}
	else {
		mode = *argv[1];
	}

	if ((ppiFD=open("/dev/ppi0", (O_RDWR))) < 0)
	{
		perror("Error opening /dev/ppi");
		return(-1);
	}
	else {
		printf("fd(%d) = open(/dev/ppi) \n", ppiFD );
	}

//Make ourselves the top priority process
//	setpriority(PRIO_PROCESS, 0 , -20);
//	srandom(time(NULL));
	
// Set PPI as Slave
	beSlave(ppiFD, IQ, bufX, bufY, dims);

	int jjj = 0, sss = 0, kkk = 0, pSize = size*2, rdByte = 0;
	float yyy = 0;

	printf("size=%d\n", size);
	printf("pSize=%d\n", pSize);

	if( pthread_create( &tid, NULL, soundproc, NULL ) ) {
		printf("Fail to create thread\n");
		exit(1);
	}

	exit_flag = 0;
	i = 0;
	buf_remainder= 0;
	cinx_w = cinx_r = 0;

//Assign File Pointers
	ofp = (FILE*)fopen(ofilename,"w");
	ofpi = (FILE*)fopen(ofilename1,"w");
	ofpq = (FILE*)fopen(ofilename2,"w");

	while(!exit_flag)
	{
		rdByte = read(ppiFD, gImage, pSize);
	
//****************************************************************************
// Decimation and IQ extraction
//****************************************************************************
		while ( i<size )
		{
			cirbuf_i[cinx_w] = (short)(gImage[i]-31500);
			cirbuf_q[cinx_w] = (short)(gImage[i+1]-31500);
			i+=40;
//			cirbuf[cinx_w] = (short)(gImage[i]-31500); i+=10;
			cinx_w++; 
			if( cinx_w > bufsize ) {
				cinx_w = 0; cinx_w_turn++;
			} 
//			printf("cinx_w_turn=%d, buf_remain=%d\n",cinx_w_turn, buf_remainder);}
			pthread_mutex_lock(&mLock);
			buf_remainder++;
			pthread_mutex_unlock(&mLock);
		}
	//printf("cinx_w=%d\n", cinx_w);

		while( buf_remainder>20000 ) {
			printf("xxx\n");
		}
	i %= (size);
//	if( cinx_w > bufsize-100 && cinx_w_turn > 0) pthread_join(tid, NULL);
	}
	printf("circular_buffer overflow!!!\n");

	fclose(ofp);
	fclose(ofpi);
	fclose(ofpq);
//	fclose(gfp);

// Sound card closing
	close(ofd);
// PPI Closing
	closePPI(ppiFD);
	
	printf (" main program finished \n");
	return (0);
} // End of main()



void *soundproc( void *arg )
{
	float scale_factor = 20000;//3000;//1800.0;
	float err, cv;
	short nco_i_in, nco_q_in, gain_out;
	float err_temp, gain_temp, agc;
	short freq_index_tmp = 0;
	int freq_index = 0;
	int max_freq_index = 62832;	
	int prev_max = 1; //SHRT_MAX
	int cur_max = 1; 
//	struct aiocb *cbp;
	nco_i_in = 20000; nco_q_in = 20000;

	//int i=0, j=0;
	int rndtime=16;
	int nnn = 0,sss=0,xxx=0,www=0,bbb=0;
	int waitfor_reading = 0, cinx_r_temp;
	short *sndbuf;
	//FILE *sfp = fopen("babo.txt", "w+");
	//printf("size=%d\n", size);
	sndbuf = (short*)malloc(rndtime*sizeof(short));
	if(sndbuf==NULL){printf("malloc error:sndbuf\n"); exit(1);}

	while(!exit_flag)
	{
		if( buf_remainder > rndtime )
		{
			//printf("j=%d\n",buf_remainder);
			pthread_mutex_lock(&mLock);
			//sss = rndtime; 
			buf_remainder -= (rndtime+1);
			pthread_mutex_unlock(&mLock);

			for (nnn=0; nnn<rndtime; nnn++){

				if (cirbuf_i[cinx_r] > cur_max) cur_max = cirbuf_i[cinx_r];
//				agc = 2600.0/prev_max;
//				err_temp = (float)(cirbuf_i[cinx_r]*agc*nco_q_in-cirbuf_q[cinx_r]*agc*nco_i_in)/scale_factor;
				err_temp = (float)(cirbuf_i[cinx_r]*nco_q_in-cirbuf_q[cinx_r]*nco_i_in)/scale_factor;
				//printf("cirbuf_i=%f\n",cirbuf_i[cinx_r]);
				//printf("err_temp=%f\n",err_temp);
				//if(err_temp > 32768) err = 32768;
				//else if (err_temp < -32768) err = -32768;
				//else err = err_temp;
				//printf("err=%f\n",err);
				
				gain_temp = 0.2747*err_temp; //gain_temp = gain(1.25,err);

//				if(gain_temp > 32768)  gain_out = 32768;
//				else if (gain_temp < -32768) gain_out = -32768;
//				else gain_out = (short)gain_temp;
	
				cv = gain_temp;
				sndbuf[nnn] = (short)(gain_temp)+1100;
				cirbuf[cinx_r] = (short)(gain_temp)+1100;
// *******************************************************************************
				if (cv > 32768) cv = 32768;
				else if (cv < -32768) cv = -32768;
	
				freq_index+=(short)gain_temp;
	
				if (freq_index > max_freq_index)
					freq_index = freq_index - max_freq_index;
				else if (freq_index < 0)
					   freq_index = freq_index + max_freq_index;
// *******************************************************************************
//				//nco_i_in = (30000.0 * cos(twopi * (float)freq_index/(float)max_freq_index));
//				//nco_q_in = (30000.0 * sin(twopi * (float)freq_index/(float)max_freq_index));
//				//freq_index_tmp = 0.0001*freq_index;
				freq_index_tmp = (short)(0.01*freq_index);
//				//printf("freq_index_tmp = %d\n", freq_index_tmp);
//				//nco_i_in = (short)(30000.0*cos(freq_index_tmp));
//				//nco_q_in = (short)(30000.0*sin(freq_index_tmp));
				if (freq_index_tmp > 627) freq_index_tmp -= 627;
				nco_i_in = cos_tab[freq_index_tmp];
				nco_q_in = sin_tab[freq_index_tmp];
	
				prev_max = cur_max;
				cinx_r++; if(cinx_r > bufsize) {cinx_r = 0; }
	
			}

/*
			for(nnn=0; nnn<rndtime; nnn++)
			{
				sndbuf[nnn]=cirbuf_i[cinx_r];
				cirbuf[cinx_r]=cirbuf_i[cinx_r];
				cinx_r++; if(cinx_r > bufsize) {cinx_r = 0; }
			}
*/
			
// Soundcard Playback			
			www = write( ofd, sndbuf, rndtime*2); //sizeof(short)
			//printf("cinx_w=%d\n", cinx_w);
// File output of samples			
/*			if (cinx_w > bufsize-100 && cinx_w_turn > 0) {		
				pthread_mutex_lock(&mLock);
				exit_flag = 1;

				for(bbb=0; bbb<bufsize-100;bbb++) {
//					fprintf(ofp, "%d\n", sndbuf[bbb]);
					fprintf(ofpi, "%d\n", cirbuf_i[bbb]);
					fprintf(ofpq, "%d\n", cirbuf_q[bbb]);
					fprintf(gfp, "%d\n", cirbuf[bbb]);
				}
	
				printf("cinx_w=%d, cinx_r=%d, exit_flag=%d\n", cinx_w, cinx_r, exit_flag);
				
				for(bbb=0; bbb<cinx_r; bbb+=rndtime) {
					write(ofd, cirbuf+bbb, rndtime*2);
				}
				
				for(bbb=0; bbb<cinx_r; bbb++) {
					fprintf(ofp, "%d\n", cirbuf[bbb]);
				}
				pthread_mutex_unlock(&mLock);

			}	
*/
		}
	}

	//	fclose(sfp);
	//	free(sndbuf);
		pthread_exit(NULL);	
}
